Regime = {};

function Regime.prerequisitesPresent(specializations)
      return true;
end;

function Regime:load(xmlFile)
		
	if self.isClient then
		   self.sampleMoto = Utils.loadSample(xmlFile, {}, "vehicle.motoSound", nil, self.baseDirectory, self.components[1].node);
           self.motoSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchOffset"), 0);
           self.motoSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchScale"), 0.05);
           self.motoSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchMax"), 2.0);
           self.motoSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#volume"), 1.0);
	end;
   self.motoSoundEnabled = false;
   
    self.regime2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime2#index"));
	self.regime3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime3#index"));	
    self.activationregime = false;
end;


function Regime:delete()
end;
	
function Regime:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Regime:keyEvent(unicode, sym, modifier, isDown)     
end;

function Regime:readStream(streamId, connection)  
end;

function Regime:writeStream(streamId, connection)
end;

function Regime:update(dt)	
Utils.play3DSample(self.sampleMoto, 0, 0, nil);	
    if self.isMotorStarted then
		if self.isClient then
			if self:getIsActiveForSound() then
				if Utils.isSamplePlaying(self.sampleMotorStart, 1.5*dt) then
				self.activationregime = false;
				Utils.stopSample(self.sampleMoto, true);
				else 
				self.activationregime =  true;
				Utils.play3DSample(self.sampleMoto, 0, 0, nil);
				end;
				if self.activationregime then
					Utils.play3DSample(self.sampleMoto, 0, 0, nil);				
					local x,y,z = getWorldTranslation(self.regime3);
					local a,b,c = getWorldTranslation(self.regime2);
					local benne = Utils.vector3Length(x-a, y-b, z-c);
					if self.sampleMoto ~= nil then				
						local motoSoundPitch = math.min(self.motoSoundPitchOffset + self.motorSoundPitchScale*math.abs(benne*4), self.motorSoundPitchMax)
						Utils.setSamplePitch(self.sampleMoto, motoSoundPitch);
						self.motoSoundEnabled = true;
					end;			  
				end;				
	        end;
		end;	
	end;
end;

function Regime:updateTick(dt)
end;

function Regime:onLeave()
      if self.isClient then  
           if self.sampleMoto ~= nil then
               Utils.stopSample(self.sampleMoto, true);
               self.motoSoundEnabled = false;
           end;
		self.translationMax2 = false;
       end;	   
end;  

function Regime:onDeactivate()
      if self.isClient then	  
           if self.sampleMoto ~= nil then
               Utils.stopSample(self.sampleMoto, true);
               self.motoSoundEnabled = false;
           end;
		self.translationMax2 = false;
       end;
end;

function Regime:draw()
end;

function Regime:onDetach()
end;